﻿#define OR_DESIGNER
// --------//-#define SQL
#define LINQtoSQL
//-#define LINQtoDataSet
//-#define LINQtoObjects
//-#define LINQtoXML
// --------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PerfectCS_2012
{
    class Program
    {
#if OR_DESIGNER
        // --------
        private const string c_cityName_Rome = "Rome";
        private static Model_CityMonthlyTemperatures[] s_cityMonthlyTemperatures_Rome = new Model_CityMonthlyTemperatures[]
        {
            new Model_CityMonthlyTemperatures(){CityName=c_cityName_Rome,   Month=1,    MaxTemp=12, MinTemp=3},
            new Model_CityMonthlyTemperatures(){CityName=c_cityName_Rome,   Month=2,    MaxTemp=13, MinTemp=4},
            new Model_CityMonthlyTemperatures(){CityName=c_cityName_Rome,   Month=3,    MaxTemp=15, MinTemp=5},
            new Model_CityMonthlyTemperatures(){CityName=c_cityName_Rome,   Month=4,    MaxTemp=19, MinTemp=7},
            new Model_CityMonthlyTemperatures(){CityName=c_cityName_Rome,   Month=5,    MaxTemp=23, MinTemp=12},
            new Model_CityMonthlyTemperatures(){CityName=c_cityName_Rome,   Month=6,    MaxTemp=28, MinTemp=15},
            new Model_CityMonthlyTemperatures(){CityName=c_cityName_Rome,   Month=7,    MaxTemp=31, MinTemp=18},
            new Model_CityMonthlyTemperatures(){CityName=c_cityName_Rome,   Month=8,    MaxTemp=31, MinTemp=18},
            new Model_CityMonthlyTemperatures(){CityName=c_cityName_Rome,   Month=9,    MaxTemp=28, MinTemp=15},
            new Model_CityMonthlyTemperatures(){CityName=c_cityName_Rome,   Month=10,   MaxTemp=22, MinTemp=11},
            new Model_CityMonthlyTemperatures(){CityName=c_cityName_Rome,   Month=11,   MaxTemp=17, MinTemp=7},
            new Model_CityMonthlyTemperatures(){CityName=c_cityName_Rome,   Month=12,   MaxTemp=13, MinTemp=4},
        };
#else
        // --------
        private const string c_cityName_Tokyo = "Tokyo";
        private static CityMonthlyTemperature[] s_cityMonthlyTemperatures_Tokyo = new CityMonthlyTemperature[]
        {
            new CityMonthlyTemperature(c_cityName_Tokyo,      1,     9.8,    2.1),
            new CityMonthlyTemperature(c_cityName_Tokyo,      2,    10.0,    2.4),
            new CityMonthlyTemperature(c_cityName_Tokyo,      3,    12.9,    5.1),
            new CityMonthlyTemperature(c_cityName_Tokyo,      4,    18.4,   10.5),
            new CityMonthlyTemperature(c_cityName_Tokyo,      5,    22.7,   15.1),
            new CityMonthlyTemperature(c_cityName_Tokyo,      6,    25.2,   18.9),
            new CityMonthlyTemperature(c_cityName_Tokyo,      7,    29.0,   22.5),
            new CityMonthlyTemperature(c_cityName_Tokyo,      8,    30.8,   24.2),
            new CityMonthlyTemperature(c_cityName_Tokyo,      9,    26.8,   20.7),
            new CityMonthlyTemperature(c_cityName_Tokyo,     10,    21.6,   15.0),
            new CityMonthlyTemperature(c_cityName_Tokyo,     11,    16.7,    9.5),
            new CityMonthlyTemperature(c_cityName_Tokyo,     12,    12.3,    4.6),
        };
        // --------
        private const string c_cityName_Honolulu = "Honolulu";
#if true
        private static CityMonthlyTemperature[] s_cityMonthlyTemperatures_Honolulu = new CityMonthlyTemperature[]
        {
            new CityMonthlyTemperature(c_cityName_Honolulu,      1,    27,   18),
            new CityMonthlyTemperature(c_cityName_Honolulu,      2,    27,   18),
            new CityMonthlyTemperature(c_cityName_Honolulu,      3,    28,   19),
            new CityMonthlyTemperature(c_cityName_Honolulu,      4,    29,   20),
            new CityMonthlyTemperature(c_cityName_Honolulu,      5,    31,   22),
            new CityMonthlyTemperature(c_cityName_Honolulu,      6,    31,   22),
            new CityMonthlyTemperature(c_cityName_Honolulu,      7,    31,   22),
            new CityMonthlyTemperature(c_cityName_Honolulu,      8,    31,   23),
            new CityMonthlyTemperature(c_cityName_Honolulu,      9,    31,   22),
            new CityMonthlyTemperature(c_cityName_Honolulu,     10,    31,   22),
            new CityMonthlyTemperature(c_cityName_Honolulu,     11,    29,   21),
            new CityMonthlyTemperature(c_cityName_Honolulu,     12,    28,   19),
        };
#else
        // --------
        private static List<CityMonthlyTemperature> s_cityMonthlyTemperatures_Honolulu = new List<CityMonthlyTemperature>
        {
            new CityMonthlyTemperature(){CityName=c_cityName_Honolulu,     Month=1,     MaxTemp=27,   MinTemp=18},
            new CityMonthlyTemperature(){CityName=c_cityName_Honolulu,     Month=2,     MaxTemp=27,   MinTemp=18},
            new CityMonthlyTemperature(){CityName=c_cityName_Honolulu,     Month=3,     MaxTemp=28,   MinTemp=19},
            new CityMonthlyTemperature(){CityName=c_cityName_Honolulu,     Month=4,     MaxTemp=29,   MinTemp=20},
            new CityMonthlyTemperature(){CityName=c_cityName_Honolulu,     Month=5,     MaxTemp=31,   MinTemp=22},
            new CityMonthlyTemperature(){CityName=c_cityName_Honolulu,     Month=6,     MaxTemp=31,   MinTemp=22},
            new CityMonthlyTemperature(){CityName=c_cityName_Honolulu,     Month=7,     MaxTemp=31,   MinTemp=22},
            new CityMonthlyTemperature(){CityName=c_cityName_Honolulu,     Month=8,     MaxTemp=31,   MinTemp=23},
            new CityMonthlyTemperature(){CityName=c_cityName_Honolulu,     Month=9,     MaxTemp=31,   MinTemp=22},
            new CityMonthlyTemperature(){CityName=c_cityName_Honolulu,     Month=10,    MaxTemp=31,   MinTemp=22},
            new CityMonthlyTemperature(){CityName=c_cityName_Honolulu,     Month=11,    MaxTemp=29,   MinTemp=21},
            new CityMonthlyTemperature(){CityName=c_cityName_Honolulu,     Month=12,    MaxTemp=28,   MinTemp=19},
        };
#endif
#endif
        // --------
        static bool IsSelected(int num)
        {
            System.Threading.Thread.Sleep(100);
            return ((num % 10) == 0); 
        }
        // --------
        static void Main(string[] args)
        {
#if false    // ---- AsParallel
            var source = Enumerable.Range(0, 100);

            // Result sequence might be out of order.
            var query = from num in source.AsParallel().AsOrdered()
                where Program.IsSelected(num)
                select num;

            // Process result sequence in parallel
            //-parallelQuery.ForAll((e) => DoSomething(e));

            // ----
            DateTime startTime = DateTime.Now;
            // ----
            // Or use foreach to merge results first.
            foreach (var num in query)//-.AsParallel())
            {
                Console.Write(" > {0}", num);
            }
            // ----
            DateTime stopTime = DateTime.Now;
            // ----
            Console.WriteLine("\n{0}", ((stopTime - startTime).TotalMilliseconds / 1000).ToString());
#endif

            //-Program_ExtensionMethod.Test1();
            //-Program_QueryExpression.Test1();

            // ----
#if false
            Program_LambdaExpression.Test1();
#endif
#if false
            Example_Object example_Object = new Example_Object();
            example_Object.Test();
#endif
            //-Example_Var example_Var = new Example_Var();
            //-example_Var.Test();

            //-Example_ObjectInitializer example_ObjectInitializer = new Example_ObjectInitializer();
            //-example_ObjectInitializer.Test1();

            //-Example_Anonymity example_Anonymity = new Example_Anonymity();
            //-example_Anonymity.Test();

            // ----
            double borderTemp = 25.0;
#if SQL
            // ---- Exapmle_SQL
            Exapmle_SQL exapmle_SQL = new Exapmle_SQL();
            exapmle_SQL.Select(c_cityName_Tokyo, borderTemp);
            exapmle_SQL.Select(c_cityName_Rome, borderTemp);
#endif
#if LINQtoSQL
            // ---- Exapmle_LINQtoSQL
            Exapmle_LINQtoSQL exapmle_LINQtoSQL = new Exapmle_LINQtoSQL();
#if OR_DESIGNER
            exapmle_LINQtoSQL.Select(c_cityName_Rome, borderTemp);
#else
            exapmle_LINQtoSQL.Select(c_cityName_Tokyo, borderTemp);
#endif
#if true
            // ---- Exapmle_LINQtoSQL(Update)
            //-string mark = "*";
            //-exapmle_LINQtoSQL.Update(c_cityName_Rome, borderTemp, mark);
            //-exapmle_LINQtoSQL.Select(c_cityName_Rome, 0);

            // ---- Exapmle_LINQtoSQL(Delete)
            //-exapmle_LINQtoSQL.Delete(c_cityName_Rome, mark);
            //-exapmle_LINQtoSQL.Select(c_cityName_Rome, 0);

            //-exapmle_LINQtoSQL.Delete_NullMark(c_cityName_Rome);
            //-exapmle_LINQtoSQL.Select(c_cityName_Rome, 0);

            // ---- Exapmle_LINQtoSQL(Insert)
#if OR_DESIGNER
            //-exapmle_LINQtoSQL.Insert(s_cityMonthlyTemperatures_Rome);
            //-exapmle_LINQtoSQL.Select(c_cityName_Rome, 0);
#else
            exapmle_LINQtoSQL.Insert(s_cityMonthlyTemperatures_Tokyo);
            exapmle_LINQtoSQL.Select(c_cityName_Tokyo, 0);

            //-exapmle_LINQtoSQL.Insert(s_cityMonthlyTemperatures_Honolulu);
            //-exapmle_LINQtoSQL.Select(c_cityName_Honolulu, 0);
#endif

#endif
#endif
#if LINQtoDataSet
            // ---- Exapmle_LINQtoDataSet
            Exapmle_LINQtoDataSet exapmle_LINQtoDataSet = new Exapmle_LINQtoDataSet();
            //-exapmle_LINQtoDataSet.Select(c_cityName_Tokyo, borderTemp);
            exapmle_LINQtoDataSet.Select(c_cityName_Rome, borderTemp);
#endif
#if LINQtoObjects
            // ---- Exapmle_LINQtoObjects
            Exapmle_LINQtoObjects exapmle_LINQtoObjects = new Exapmle_LINQtoObjects();
            exapmle_LINQtoObjects.Select(c_cityName_Tokyo, borderTemp);
            //-exapmle_LINQtoObjects.Select(c_cityName_Rome, borderTemp);

            // ----
            //-exapmle_LINQtoObjects.Select_from(c_cityName_Tokyo, borderTemp);
            //-exapmle_LINQtoObjects.Select_select(c_cityName_Tokyo, borderTemp);
            //-exapmle_LINQtoObjects.Select_group(borderTemp);

            // ----
            //-exapmle_LINQtoObjects.Select_InnerJoin(c_cityName_Tokyo, borderTemp);
            //-exapmle_LINQtoObjects.Select_InnerJoin(c_cityName_Rome, borderTemp);
#endif
#if LINQtoXML
            // ---- Exapmle_LINQtoXML
            Exapmle_LINQtoXML exapmle_LINQtoXML = new Exapmle_LINQtoXML();
            exapmle_LINQtoXML.Select(c_cityName_Tokyo, borderTemp);
            exapmle_LINQtoXML.Select(c_cityName_Rome, borderTemp);
#endif
            // ----
            Console.ReadLine();
        }
    }
}
