﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;

namespace StateManagement
{
    public class Global : System.Web.HttpApplication
    {

        protected void Application_Start(object sender, EventArgs e)
        {
            try
            {
                DataSet globalDataSet = LoadGlobalData();
                Application.Lock(); // ロック
                Application["AppConfigDataSet"] = globalDataSet; // DataSetを格納
            }
            finally
            {
                Application.UnLock(); // ロック解除
            }
        }

        private DataSet LoadGlobalData()
        {
            return new DataSet(); // 実際はここでデータセットをロード
        }

        protected void Session_Start(object sender, EventArgs e)
        {

        }

        protected void Application_BeginRequest(object sender, EventArgs e)
        {

        }

        protected void Application_AuthenticateRequest(object sender, EventArgs e)
        {

        }

        protected void Application_Error(object sender, EventArgs e)
        {

        }

        protected void Session_End(object sender, EventArgs e)
        {

        }

        protected void Application_End(object sender, EventArgs e)
        {

        }
    }
}