﻿using System;
using System.Windows.Media;

namespace DataBindSample
{
    public class Magazine
    {
        public Magazine()
        {
        }

        /// <summary>
        /// 雑誌タイトル
        /// </summary>
        public string Title{
            get { return this._title; }
            set { this._title = value; }
        }
        private string _title;

        /// <summary>
        /// 価格
        /// </summary>
        public int Price
        {
            get { return this._price; }
            set { this._price = value; }
        }
        private int _price;

        /// <summary>
        /// 発行日
        /// </summary>
        public DateTime PublishDate
        {
            get { return this._publishDate; }
            set { this._publishDate = value; }
        }
        private DateTime _publishDate;

        /// <summary>
        /// イメージカラー
        /// </summary>
        public Color ImageColor
        {
            get { return this._ImaegColor; }
            set { this._ImaegColor = value; }
        }
        private Color _ImaegColor;

        /// <summary>
        /// オブジェクトの文字列表現を返却します
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            return "これはMagazineオブジェクトです． " + "Title=" + Title;
        }
    }
}
