﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

// --------
using System.IO;
using System.Xml.Linq;

// --------
namespace PerfectCS_2012
{
    public class Exapmle_LINQtoXML
    {
        public Exapmle_LINQtoXML()
        {
            // -------- データソース
            XElement cityMonthlyTemperaturesXML =
                new XElement(c_tag_CityMonthlyTemperatures,
                    new XElement(c_tag_CityMonthlyTemperature,
                        new XElement(c_tag_CityName, "Tokyo"),
                        new XElement(c_tag_MonthlyTemperatures,
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "1"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "9.8"),
                                new XElement(c_tag_MinTemp, "2.1")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "2"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "10.0"),
                                new XElement(c_tag_MinTemp, "2.4")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "3"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "12.9"),
                                new XElement(c_tag_MinTemp, "5.1")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "4"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "18.4"),
                                new XElement(c_tag_MinTemp, "10.5")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "5"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "22.7"),
                                new XElement(c_tag_MinTemp, "15.1")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "6"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "25.2"),
                                new XElement(c_tag_MinTemp, "18.9")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "7"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "29.0"),
                                new XElement(c_tag_MinTemp, "22.5")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "8"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "30.8"),
                                new XElement(c_tag_MinTemp, "24.2")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "9"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "26.8"),
                                new XElement(c_tag_MinTemp, "20.7")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "10"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "21.6"),
                                new XElement(c_tag_MinTemp, "15.0")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "11"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "16.7"),
                                new XElement(c_tag_MinTemp, "9.5")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "12"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "12.3"),
                                new XElement(c_tag_MinTemp, "4.6"))
                        )
                    ),
                    new XElement(c_tag_CityMonthlyTemperature,
                        new XElement(c_tag_CityName, "Rome"),
                        new XElement(c_tag_MonthlyTemperatures,
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "1"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "12"),
                                new XElement(c_tag_MinTemp, "3")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "2"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "13"),
                                new XElement(c_tag_MinTemp, "4")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "3"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "15"),
                                new XElement(c_tag_MinTemp, "5")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "4"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "19"),
                                new XElement(c_tag_MinTemp, "7")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "5"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "23"),
                                new XElement(c_tag_MinTemp, "12")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "6"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "28"),
                                new XElement(c_tag_MinTemp, "15")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "7"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "31"),
                                new XElement(c_tag_MinTemp, "18")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "8"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "31"),
                                new XElement(c_tag_MinTemp, "18")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "9"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "28"),
                                new XElement(c_tag_MinTemp, "15")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "10"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "22"),
                                new XElement(c_tag_MinTemp, "11")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "11"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "17"),
                                new XElement(c_tag_MinTemp, "7")),
                            new XElement(c_tag_MonthlyTemperature, new XAttribute(c_name_Month, "12"), new XAttribute(c_name_Mark, string.Empty),
                                new XElement(c_tag_MaxTemp, "13"),
                                new XElement(c_tag_MinTemp, "4"))
                        )
                    )
                );
            // ----
            m_cityMonthlyTemperaturesXMLWriter = new StringWriter();
            cityMonthlyTemperaturesXML.Save(m_cityMonthlyTemperaturesXMLWriter);
            // ----
            Console.WriteLine(m_cityMonthlyTemperaturesXMLWriter.ToString());
        }
        private StringWriter m_cityMonthlyTemperaturesXMLWriter;
        //private XElement m_cityMonthlyTemperatures;
        // --------
        private string c_tag_CityMonthlyTemperatures = "CityMonthlyTemperatures";
        private string c_tag_CityMonthlyTemperature = "CityMonthlyTemperature";
        private string c_tag_MonthlyTemperatures = "MonthlyTemperatures";
        private string c_tag_MonthlyTemperature = "MonthlyTemperature";
        // --------
        private string c_tag_CityName = "CityName";
        private string c_name_Month = "Month";
        private string c_tag_MaxTemp = "MaxTemp";
        private string c_tag_MinTemp = "MinTemp";
        private string c_name_Mark = "Mark";

        // --------
        public void Select(string cityName, double borderTemp)
        {
            XElement cityMonthlyTemperaturesXML = XElement.Parse(m_cityMonthlyTemperaturesXMLWriter.ToString());

            // ---- ①クエリの作成
            IEnumerable<XElement> query =
                from cityMonthlyTemperature in cityMonthlyTemperaturesXML.Descendants(c_tag_MonthlyTemperature)
                where (string)cityMonthlyTemperature.Parent.Parent.Element(c_tag_CityName) == cityName &&
                        (double)cityMonthlyTemperature.Element(c_tag_MaxTemp) >= borderTemp
                orderby (double)cityMonthlyTemperature.Element(c_tag_MaxTemp) descending
                select cityMonthlyTemperature;

            // ---- ②クエリの実行
            Console.WriteLine("-------- Exapmle_LINQtoXML");
            foreach (XElement cityMonthlyTemperature in query)
            {
                //-ConsoleTrace.WriteValue(c_tag_MonthlyTemperature, cityMonthlyTemperature);
                // ----
                Console.WriteLine("{0}[{1:d2}] {2:n1} - {3:n1} {4}",
                    cityName,
                    (int)cityMonthlyTemperature.Attribute(c_name_Month),
                    (double)cityMonthlyTemperature.Element(c_tag_MaxTemp),
                    (double)cityMonthlyTemperature.Element(c_tag_MinTemp),
                    (string)cityMonthlyTemperature.Attribute(c_name_Mark));
            }
            
        }
    }
}
