﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PerfectCS_2012
{
    [System.Data.Linq.Mapping.Table(Name = "dbo.Table_CityMonthlyTemperatures")]
    public class CityMonthlyTemperature
    {
		public CityMonthlyTemperature()
		{
            // ----
		}
        // --------
        public CityMonthlyTemperature(string cityName, int month, double maxTemp, double minTemp)
            : this(cityName, month, maxTemp, minTemp, null)
        {
            // ----
        }
        // --------
        
        public CityMonthlyTemperature(string cityName, int month, double maxTemp, double minTemp, string mark)
        {
            this.CityName = cityName;
            this.Month = month;
            this.MaxTemp = maxTemp;
            this.MinTemp = minTemp;
            this.Mark = mark;
        }

        // --------
        private string m_id;
        [System.Data.Linq.Mapping.Column(Storage = "m_id", DbType = "NChar(20) NOT NULL", CanBeNull = false, IsPrimaryKey = true)]
        public string Id
        {
            get { return m_id; }
            set { m_id = value; }
        }

        // --------
        private string m_cityName;
        [System.Data.Linq.Mapping.Column(Storage = "m_cityName", DbType = "NChar(10)")]
        public string CityName
        {
            get { return m_cityName; }
            set { m_cityName = value; }
        }

        // --------
        private int m_month;
        [System.Data.Linq.Mapping.Column(Storage = "m_month", DbType = "Int")]
        public int Month
        {
            get { return m_month; }
            set { m_month = value; }
        }

        // --------
        private double m_maxTemp;
        [System.Data.Linq.Mapping.Column(Storage = "m_maxTemp", DbType = "Float")]
        public double MaxTemp
        {
            get { return m_maxTemp; }
            set { m_maxTemp = value; }
        }

        // --------
        private double m_minTemp;
        [System.Data.Linq.Mapping.Column(Storage = "m_minTemp", DbType = "Float")]
        public double MinTemp
        {
            get { return m_minTemp; }
            set { m_minTemp = value; }
        }

        // --------
        private string m_mark;
        [System.Data.Linq.Mapping.Column(Storage = "m_mark", DbType = "NChar(10)")]
        public string Mark
        {
            get { return m_mark; }
            set { m_mark = value; }
        }

        // --------
        public void Trace()
        {
            ConsoleTrace.WriteValueList(this.CityName, this.Month, this.MaxTemp, this.MinTemp, this.Mark);
        }
    }
}
