﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace WpfApplication
{
    /// <summary>
    /// CallModalWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class CallModalWindow : Window
    {
        public CallModalWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            ProfileWindow profileWindow = new ProfileWindow();
            profileWindow.Owner = this;
            // 既存設定値をダイアログに設定
            profileWindow.FirstName = this.tbFirstName.Text;
            profileWindow.LastName = this.tbLastName.Text;
            if (this.tbSex.Text == "Male")
                profileWindow.Sex = Sex.Male;
            else if (this.tbSex.Text == "Female")
                profileWindow.Sex = Sex.Female;
            if (true == profileWindow.ShowDialog())
            {
                // ダイアログ値を既存設定値に保存
                this.tbFirstName.Text = profileWindow.FirstName;
                this.tbLastName.Text = profileWindow.LastName;
                if (Sex.Male == profileWindow.Sex)
                    this.tbSex.Text = "Male";
                else if (Sex.Female == profileWindow.Sex)
                    this.tbSex.Text = "Female";
            }
        }
    }
}
