﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace ControlSample
{
    /// <summary>
    /// TestWindows.xaml の相互作用ロジック
    /// </summary>
    public partial class TestWindows : Window
    {
        public TestWindows()
        {
            InitializeComponent();
/*
            PoorPanel poorPanel = new PoorPanel();
            this.Content = poorPanel;
            Label label1 = new Label();
            label1.Content = "Hello!!!";
            poorPanel.Children.Add(label1);
            Label label2 = new Label();
            label2.Content = "Hello!!!";
            poorPanel.Children.Add(label2);
            Label label3 = new Label();
            label3.Content = "Hello!!!";
            poorPanel.Children.Add(label3);
*/
            
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {

        }
/*
        private void button2_Click(object sender, RoutedEventArgs e)
        {
            //MessageBox.Show(this.label1.ActualWidth.ToString() + ", " + this.label1.ActualHeight.ToString());
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            MessageBox.Show(Label1.ActualWidth.ToString() + ", " + this.Label1.ActualHeight.ToString());
            MessageBox.Show(Label2.ActualWidth.ToString() + ", " + this.Label2.ActualHeight.ToString());
            MessageBox.Show(Label3.ActualWidth.ToString() + ", " + this.Label3.ActualHeight.ToString());
            MessageBox.Show(Label4.ActualWidth.ToString() + ", " + this.Label4.ActualHeight.ToString());
            MessageBox.Show(Label5.ActualWidth.ToString() + ", " + this.Label5.ActualHeight.ToString());
            MessageBox.Show(Label6.ActualWidth.ToString() + ", " + this.Label6.ActualHeight.ToString());
        }
*/
    }

    public class PoorPanel : Panel
    {
        public PoorPanel()
        {
        }

        protected override Size MeasureOverride(Size availableSize)
        {
            //return base.MeasureOverride(availableSize);
            double height = 0;

            foreach (UIElement uie in Children)
            {
                //uie.Measure(new Size(Double.PositiveInfinity, Double.PositiveInfinity));
                uie.Measure(new Size(Double.PositiveInfinity, Double.PositiveInfinity));
                height += uie.DesiredSize.Height;
            }
            return new Size(100, height);
        }

        protected override Size ArrangeOverride(Size finalSize)
        {
            //return base.ArrangeOverride(finalSize);
            int x = 0;
            int y = 0;

            foreach (UIElement uie in Children)
            {
                uie.Arrange( 
                    new Rect(
                        new Point(x, y), 
                        new Size(uie.DesiredSize.Width, uie.DesiredSize.Height)));
                y += 50;
            }

            return finalSize;
        }
    }
}
