﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace DataBindSample
{
    /// <summary>
    /// DataBindByCode.xaml の相互作用ロジック
    /// </summary>
    public partial class DataBindByCode : Window
    {
        public DataBindByCode()
        {
            InitializeComponent();

            InitializeDataBinding();
        }

        protected void InitializeDataBinding()
        {
            Binding binding = new Binding();
            binding.Source = this.txtName;
            binding.Path = new PropertyPath("Text");
            tbName.SetBinding(TextBlock.TextProperty, binding);
        }
    }
}
